{$MODE DELPHI}

unit XAudio;

(*************************************************************************)
(*  XAudio for FreePascal unit (DOS)                                     *)
(*************************************************************************)
(*  This is a inport unit for MpegTV's XAudio, a MP3 decoding library    *)
(*  for various platforms. This unit provides XAudio access under DOS.   *)
(*  Note this is a very early version. The code isn't very clean and it  *)
(*  may have some little bugs (I've tested the unit for a long time,     *)
(*  anyway).                                                             *)
(*  PLEASE E-MAIL ME IF YOU FIND BUGS OR HAVE QUESTIONS.                 *)
(*                                                                       *)
(*  Unit made by: Udo Giacomozzi                                         *)
(*  e-mail: ugcm@usa.net                                                 *)
(*  homepage: http://come.to/jampy                                       *)
(*                                                                       *)
(*  Unit version: 1.0 (July 1999)                                        *)
(*  XAudio libary version: 1.2.0                                         *)
(*  Compiler: FreePascal for DOS                                         *)
(*                                                                       *)
(*  Comments: Requires some installation steps, refer the file           *)
(*            'install.txt' for more information.                        *)
(*************************************************************************)

{ Revision history:

  1.0 (31 July 1999) Udo Giacomozzi
      - first public release, works fine

}

{  Automatically converted by H2PAS.EXE from decoder.h
   Utility made by Florian Klaempfl 25th-28th september 96
   Improvements made by Mark A. Malakanov 22nd-25th may 97
   Further improvements by Michael Van Canneyt, April 1998
   define handling and error recovery by Pierre Muller, June 1998 }

{ INCLUDES:
   - XAUDIO.H
   - FILE_INPUT.H
   - AUDIO_OUTPUT.H
}


interface

uses
  dpmiexcp;

  { C default packing is dword }

{$PACKRECORDS 4}
  {
  |
  |      MPEG audio decoder. SYNC API
  |
  |      (c) 1996-1998 MpegTV, LLC
  |      Author: Gilles Boccon-Gibod (gilles@mpegtv.com)
  |
                                                                   }

  {----------------------------------------------------------------------
  |       constants
  +--------------------------------------------------------------------- }

  {$include xaudio.inc}

  {----------------------------------------------------------------------
  |       types
  +--------------------------------------------------------------------- }

  { partly in xaudio.inc }

(* Const before type ignored *)

  type
     PInteger  = ^Integer;
     PLongInt  = ^LongInt;
     PWord     = ^Word;
     PDWord    = ^DWord;
     PByte     = ^Byte;

     float     = single;

     XA_EnvironmentCallback = procedure (listener:pointer; name:pchar; value:pointer);cdecl;


     PXA_TimeCode = ^XA_TimeCode;
     PXA_AbsoluteTime = ^XA_AbsoluteTime;
     PXA_IOState = ^XA_IOState;
     PXA_InputStreamInfo = ^XA_InputStreamInfo;
     PXA_InputModuleQuery = ^XA_InputModuleQuery;
     PXA_InputModuleClassInfo = ^XA_InputModuleClassInfo;
     PPXA_DecoderInfo = ^PXA_DecoderInfo;
     PXA_DecoderInfo = ^XA_DecoderInfo;
     PXA_InputModule = ^XA_InputModule;
     PXA_InputInfo = ^XA_InputInfo;
     PXA_OutputChannelsMode = ^XA_OutputChannelsMode;
     PXA_OutputModule = ^XA_OutputModule;
     PXA_OutputInfo = ^XA_OutputInfo;
     PXA_InputFilterNode = ^XA_InputFilterNode;
     PXA_InputFilter = ^XA_InputFilter;
     PXA_OutputBufferInfo = ^XA_OutputBufferInfo;
     PXA_OutputStatus = ^XA_OutputStatus;
     PXA_OutputControl = ^XA_OutputControl;
     PXA_OutputModuleQuery = ^XA_OutputModuleQuery;
     PXA_OutputModuleClassInfo = ^XA_OutputModuleClassInfo;
     PXA_OutputFilterNode = ^XA_OutputFilterNode;
     PXA_OutputFilter = ^XA_OutputFilter;
     PXA_NotificationClient = ^XA_NotificationClient;
     PXA_ModulesInfo = ^XA_ModulesInfo;
     PXA_StatusInfo = ^XA_StatusInfo;
     PXA_DecoderPrivateInfo = ^XA_DecoderPrivateInfo;

(****************************************)
(****************************************)
(****************************************)

  XA_ProgressNotificationFunction = procedure (client:Pointer;
                                               source:LongInt;
                                               code  :LongInt;
                                               value :LongInt; // "long"
                                               message:PChar); cdecl;

  XA_DebugNotificationFunction = procedure (client:Pointer;
                                            source:LongInt;
                                            level:LongInt;
                                            message:PChar;
                                            reason:PChar); cdecl;

  XA_ErrorNotificationFunction = procedure (client:Pointer;
                                            source:LongInt;
                                            code:LongInt;
                                            message:PChar;
                                            reason:PChar); cdecl;


  XA_NotificationClient = record
     client               : Pointer;
     notify_progress      : XA_ProgressNotificationFunction;
     notify_debug         : XA_DebugNotificationFunction;
     notify_error         : XA_ErrorNotificationFunction;
    end;

(***********************)

     XA_DecoderCallbackTable = record
          get_environment_integer : function (decoder:pXA_DecoderInfo; name:pchar; value:plongint):longint;cdecl;
          get_environment_string : function (decoder:pXA_DecoderInfo; name:pchar; value:pchar):longint;
          add_environment_listener : function (decoder:pXA_DecoderInfo; name:pchar; client:pointer; callback:XA_EnvironmentCallback; handle:ppointer):longint;
          remove_environment_listener : function (decoder:pXA_DecoderInfo; handle:pointer):longint;
       end;


(***********************)

     XA_TimeCode = record
          h : longint;
          m : longint;
          s : longint;
          f : longint;
       end;
     (*XA_TimeCode = record
          m : longint;   { redefined because m has to be on first position }
          s : longint;   { otherwise it doesn't wor. "h" is probably useless }
          f : longint;
          h : longint;
       end;*)

     XA_AbsoluteTime = record
          seconds : longint;
          microseconds : longint;
       end;


     XA_IOState = (XA_IO_STATE_CLOSED := 0,XA_IO_STATE_OPEN
       );


     XA_InputStreamInfo = record
          changed : longint;
          level : longint;
          layer : longint;
          bitrate : longint;
          frequency : longint;
          mode : longint;
       end;

     XA_InputModuleQuery = record
          index : longint;
          flags : cardinal;
          name : array[0..(XA_DECODER_MAX_NAME_LENGTH)-1] of char;
          description : array[0..(XA_DECODER_MAX_DESCRIPTION_LENGTH)-1] of char;
       end;

     XA_InputModuleClassInfo = record
          id : longint;
          global : pointer;
       end;


     XA_InputModule = record
          input_module_probe : function (name:pchar):longint;cdecl;
          input_module_query : function (query:pXA_InputModuleQuery; query_mask:cardinal):longint;
          input_new : function (input:ppointer; name:pchar; class_info:pXA_InputModuleClassInfo; decoder:pXA_DecoderInfo):longint;
          input_delete : function (input:pointer):longint;
          input_open : function (input:pointer):longint;
          input_close : function (input:pointer):longint;
          input_read : function (input:pointer; buffer:pointer; n:cardinal):longint;
          input_seek : function (input:pointer; offset:cardinal):longint;
          input_get_caps : function (input:pointer):longint;
          input_get_size : function (input:pointer):longint;
          input_send_message : function (input:pointer; type_:longint; data:pointer; size:cardinal):longint;
       end;


     XA_InputInfo = record
          state : XA_IOState;
          caps : cardinal;
          position : cardinal;
          size : cardinal;
          duration : cardinal;
          device : pointer;
          module : PXA_InputModule;
          name : PChar;
       end;

     XA_OutputChannelsMode = (XA_OUTPUT_STEREO,XA_OUTPUT_MONO_LEFT,
       XA_OUTPUT_MONO_RIGHT,XA_OUTPUT_MONO_MIX
       );


     XA_OutputInfo = record
          state : XA_IOState;
          caps : cardinal;
          channels : XA_OutputChannelsMode;
          device : pointer;
          module : PXA_OutputModule;
          name : PChar;
       end;



     XA_DecoderInfo = record
          name : PChar;
          input : PXA_InputInfo;
          output : PXA_OutputInfo;
          modules : PXA_ModulesInfo;
          status : PXA_StatusInfo;
          output_buffer : PXA_OutputBufferInfo;
          notification_client : XA_NotificationClient;
          callbacks : XA_DecoderCallbackTable;
          hidden : PXA_DecoderPrivateInfo;
       end;



     XA_InputFilter = record
          filter_get_name : function :pchar;cdecl;
          filter_new : function (filter:ppointer; id:longint; decoder:pXA_DecoderInfo):longint;
          filter_delete : function (filter:pointer):longint;
          input_open : function (node:pXA_InputFilterNode):longint;
          input_close : function (node:pXA_InputFilterNode):longint;
          input_read : function (node:pXA_InputFilterNode; buffer:pointer; n:cardinal):longint;
          input_seek : function (node:pXA_InputFilterNode; offset:cardinal):longint;
          input_get_caps : function (node:pXA_InputFilterNode):longint;
          input_get_size : function (node:pXA_InputFilterNode):longint;
          input_send_message : function (node:pXA_InputFilterNode; type_:longint; data:pointer; size:cardinal):longint;
       end;

     XA_InputFilterNode = record
          id : longint;
          instance : pointer;
          vtable : XA_InputFilter;
          next : PXA_InputFilterNode;
          prev : PXA_InputFilterNode;
       end;


     XA_OutputBufferInfo = record
          changed : longint;
          pcm_samples : ^integer;
          size : longint;
          bytes_per_sample : longint;
          stereo : longint;
          sample_rate : longint;
          delay : cardinal;
       end;

     XA_OutputStatus = record
          buffered_bytes : cardinal;
       end;

     XA_OutputControl = record
          bytes_per_sample : longint;
          sample_rate : longint;
          stereo : longint;
          master_level : longint;
          pcm_level : longint;
          balance : longint;
          ports : longint;
       end;

     XA_OutputModuleQuery = record
          index : longint;
          flags : cardinal;
          name : array[0..(XA_DECODER_MAX_NAME_LENGTH)-1] of char;
          description : array[0..(XA_DECODER_MAX_DESCRIPTION_LENGTH)-1] of char;
       end;

     XA_OutputModuleClassInfo = record
          id : longint;
          global : pointer;
       end;

     XA_OutputModule = record
          output_module_probe : function (name:pchar):longint;cdecl;
          output_module_query : function (query:pXA_OutputModuleQuery; query_mask:cardinal):longint;
          output_new : function (output:ppointer; name:pchar; class_info:pXA_OutputModuleClassInfo; decoder:pXA_DecoderInfo):longint;
          output_delete : function (output:pointer):longint;
          output_open : function (output:pointer):longint;
          output_close : function (output:pointer):longint;
          output_write : function (output:pointer; buffer:pointer; size:cardinal; bytes_per_sample:longint; stereo:longint;
                       sample_rate:longint):longint;
          output_get_buffer : function (output:pointer; size:cardinal):pointer;
          output_set_control : function (output:pointer; control:pXA_OutputControl; flags:cardinal):longint;
          output_get_control : function (output:pointer; control:pXA_OutputControl; control_mask:cardinal):longint;
          output_get_status : function (output:pointer; status:pXA_OutputStatus):longint;
          output_get_caps : function (output:pointer):longint;
          output_send_message : function (output:pointer; type_:longint; data:pointer; size:cardinal):longint;
       end;


     XA_OutputFilter = record
          filter_get_name : function :pchar;cdecl;
          filter_new : function (filter:ppointer; id:longint; decoder:pXA_DecoderInfo):longint;
          filter_delete : function (filter:pointer):longint;
          output_open : function (node:pXA_OutputFilterNode):longint;
          output_close : function (node:pXA_OutputFilterNode):longint;
          output_write : function (node:pXA_OutputFilterNode; buffer:pointer; size:cardinal; bytes_per_sample:longint; stereo:longint;
                       sample_rate:longint):longint;
          output_get_buffer : function (node:pXA_OutputFilterNode; size:cardinal):pointer;
          output_set_control : function (node:pXA_OutputFilterNode; control:pXA_OutputControl; flags:cardinal):longint;
          output_get_control : function (node:pXA_OutputFilterNode; control:pXA_OutputControl; control_mask:cardinal):longint;
          output_get_status : function (node:pXA_OutputFilterNode; status:pXA_OutputStatus):longint;
          output_get_caps : function (node:pXA_OutputFilterNode):longint;
          output_send_message : function (node:pXA_OutputFilterNode; type_:longint; data:pointer; size:cardinal):longint;
       end;


     XA_OutputFilterNode = record
          id : longint;
          instance : pointer;
          vtable : XA_OutputFilter;
          next : PXA_OutputFilterNode;
          prev : PXA_OutputFilterNode;
       end;


(* Const before type ignored *)
(* Const before type ignored *)

  (*typedef struct {
      signed char left[32];
      signed char right[32];
  } XA_EqualizerInfo;  *)

     XA_ModulesInfo = record
          nb_input_modules : longint;
          nb_output_modules : longint;
       end;

     XA_StatusInfo = record
          frame : longint;

          position : float;
          //position_dummy:array[1..4] of byte;

          info : XA_InputStreamInfo;
          timecode : XA_TimeCode;
       end;
     XA_DecoderPrivateInfo = record
       end;



(* Const before type ignored *)


  {----------------------------------------------------------------------
  |       prototypes
  +--------------------------------------------------------------------- }
{ C++ extern C conditionnal removed }

  function decoder_version(major:ppchar; minor:ppchar; state:ppchar):pchar;cdecl;

  function decoder_new(decoder:ppXA_DecoderInfo):longint;cdecl;

  function decoder_delete(decoder:pXA_DecoderInfo):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_module_register(decoder:pXA_DecoderInfo; module:pXA_InputModule):longint;cdecl;

  function decoder_input_module_query(decoder:pXA_DecoderInfo; module:longint; query:pXA_InputModuleQuery; query_flags:cardinal):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_add_filter(decoder:pXA_DecoderInfo; filter:pXA_InputFilter; where:longint):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_remove_filter(decoder:pXA_DecoderInfo; name:pchar; id:longint):longint;cdecl;

  type difl_proc = procedure (client:pointer; node:pXA_InputFilterNode);
  function decoder_input_filters_list(decoder:pXA_DecoderInfo; client:pointer; callback:difl_proc):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_new(decoder:pXA_DecoderInfo; name:pchar; module:longint):longint;cdecl;

  function decoder_input_delete(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_input_open(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_input_close(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_input_read(decoder:pXA_DecoderInfo; buffer:pointer; size:longint):longint;cdecl;

  function decoder_input_seek_to_offset(decoder:pXA_DecoderInfo; offset:cardinal):longint;cdecl;

  function decoder_input_seek_to_position(decoder:pXA_DecoderInfo; position:float):longint;cdecl;

  function decoder_input_seek_to_time(decoder:pXA_DecoderInfo; seconds:float):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_seek_to_timecode(decoder:pXA_DecoderInfo; timecode:pXA_TimeCode):longint;cdecl;

(* Const before type ignored *)
  function decoder_input_send_message(decoder:pXA_DecoderInfo; type_:longint; data:pointer; size:cardinal):longint;cdecl;

(* Const before type ignored *)
  function decoder_output_module_register(decoder:pXA_DecoderInfo; module:pXA_OutputModule):longint;cdecl;

  function decoder_output_module_query(decoder:pXA_DecoderInfo; module:longint; query:pXA_OutputModuleQuery; query_flags:cardinal):longint;cdecl;

(* Const before type ignored *)
  function decoder_output_add_filter(decoder:pXA_DecoderInfo; filter:pXA_OutputFilter; where:longint):longint;cdecl;

(* Const before type ignored *)
  function decoder_output_remove_filter(decoder:pXA_DecoderInfo; name:pchar; id:longint):longint;cdecl;

  type dofl_proc=procedure (client:pointer; node:pXA_OutputFilterNode);
  function decoder_output_filters_list(decoder:pXA_DecoderInfo; client:pointer; callback:dofl_proc):longint;cdecl;

(* Const before type ignored *)
  function decoder_output_new(decoder:pXA_DecoderInfo; name:pchar; module:longint):longint;cdecl;

  function decoder_output_delete(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_output_open(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_output_close(decoder:pXA_DecoderInfo):longint;cdecl;

  function decoder_output_write(decoder:pXA_DecoderInfo; buffer:pointer; size:cardinal; bytes_per_sample:longint; stereo:longint;
             sample_rate:longint):longint;cdecl;

  function decoder_output_set_control(decoder:pXA_DecoderInfo; control:pXA_OutputControl; control_flags:cardinal):longint;cdecl;

  function decoder_output_get_control(decoder:pXA_DecoderInfo; control:pXA_OutputControl; control_flags:cardinal):longint;cdecl;

(* Const before type ignored *)
  function decoder_output_send_message(decoder:pXA_DecoderInfo; type_:longint; data:pointer; size:cardinal):longint;cdecl;

  function decoder_codec_set_equalizer(decoder:pXA_DecoderInfo; equalizer:pXA_EqualizerInfo):longint;cdecl;

  function decoder_codec_get_equalizer(decoder:pXA_DecoderInfo; equalizer:pXA_EqualizerInfo):longint;cdecl;

(* Const before type ignored *)
  function decoder_set_environment_integer(decoder:pXA_DecoderInfo; name:pchar; value:longint):longint;cdecl;

(* Const before type ignored *)
  function decoder_get_environment_integer(decoder:pXA_DecoderInfo; name:pchar; value:plongint):longint;cdecl;

(* Const before type ignored *)
(* Const before type ignored *)
  function decoder_set_environment_string(decoder:pXA_DecoderInfo; name:pchar; value:pchar):longint;cdecl;

(* Const before type ignored *)
  function decoder_get_environment_string(decoder:pXA_DecoderInfo; name:pchar; value:pchar):longint;cdecl;

(* Const before type ignored *)
  function decoder_unset_environment(decoder:pXA_DecoderInfo; name:pchar):longint;cdecl;

(* Const before type ignored *)
  function decoder_add_environment_listener(decoder:pXA_DecoderInfo; name:pchar; client:pointer; callback:XA_EnvironmentCallback; handle:ppointer):longint;cdecl;

  function decoder_remove_environment_listener(decoder:pXA_DecoderInfo; handle:pointer):longint;cdecl;

  function decoder_decode(decoder:pXA_DecoderInfo; output_buffer:pointer):longint;cdecl;

  function decoder_play(decoder:pXA_DecoderInfo):longint;cdecl;

  {
  #ifdef __cplusplus
  }
(*
  class XA_Decoder {
  public:
      XA_DecoderInfo  info;
      XA_Decoder() {
          info = (XA_DecoderInfo  )0;
          decoder_new(&info);
      }
      ~XA_Decoder() {
          decoder_delete(info);
      }
      char  Version(char   major, char   minor, char   state) {
          return decoder_version(major, minor, state);
      }
      int InputModuleRegister(const XA_InputModule  module) {
          return decoder_input_module_register(info, module);
      }
      int InputModuleQuery(int module, XA_InputModuleQuery  query,
                           unsigned long query_flags) {
          return decoder_input_module_query(info, module, query, query_flags);
      }
      int InputAddFilter(const XA_InputFilter  filter, int where) {
          return decoder_input_add_filter(info, filter, where);
      }
      int InputRemoveFilter(const char  name, int id) {
          return decoder_input_remove_filter(info, name, id);
      }
      int InputNew(const char  name, int module) {
          return decoder_input_new(info, name, module);
      }
      int InputDelete() {
          return decoder_input_delete(info);
      }
      int InputOpen() {
          return decoder_input_open(info);
      }
      int InputClose() {
          return decoder_input_close(info);
      }
      int InputSeekToOffset(unsigned long offset) {
          return decoder_input_seek_to_offset(info, offset);
      }
      int InputSeekToPosition(float position) {
          return decoder_input_seek_to_position(info, position);
      }
      int InputSeekToTime(float seconds) {
          return decoder_input_seek_to_time(info, seconds);
      }
      int InputSeekToTimecode(const XA_TimeCode  timecode) {
          return decoder_input_seek_to_timecode(info, timecode);
      }
      int InputSendMessage(int type, const void  data, unsigned int size) {
          return decoder_input_send_message(info, type, data, size);
      }
      int OutputModuleRegister(const XA_OutputModule  module) {
          return decoder_output_module_register(info, module);
      }
      int OutputModuleQuery(int module, XA_OutputModuleQuery  query,
                            unsigned long query_flags) {
          return decoder_output_module_query(info, module, query, query_flags);
      }
      int OutputAddFilter(const XA_OutputFilter  filter, int where) {
          return decoder_output_add_filter(info, filter, where);
      }
      int OutputRemoveFilter(const char  name, int id) {
          return decoder_output_remove_filter(info, name, id);
      }
      int OutputNew(const char  name, int module) {
          return decoder_output_new(info, name, module);
      }
      int OutputDelete() {
          return decoder_output_delete(info);
      }
      int OutputOpen() {
          return decoder_output_open(info);
      }
      int OutputClose() {
          return decoder_output_close(info);
      }
      int OutputSetControl(XA_OutputControl  control,
                           unsigned long control_flags) {
          return decoder_output_set_control(info, control, control_flags);
      }
      int OutputGetControl(XA_OutputControl  control,
                           unsigned long control_flags) {
          return decoder_output_get_control(info, control, control_flags);
      }
      int OutputSendMessage(int type, const void  data, unsigned int size) {
          return decoder_output_send_message(info, type, data, size);
      }
      int CodecSetEqualizer(XA_EqualizerInfo  equalizer) {
          return decoder_codec_set_equalizer(info, equalizer);
      }
      int CodecGetEqualizer(XA_EqualizerInfo  equalizer) {
          return decoder_codec_get_equalizer(info, equalizer);
      }
      int SetEnvironmentInteger(const char  name, long value) {
          return decoder_set_environment_integer(info, name, value);
      }
      int GetEnvironmentInteger(const char  name, long  value) {
          return decoder_get_environment_integer(info, name, value);
      }
      int SetEnvironmentString(const char  name, const char  value) {
          return decoder_set_environment_string(info, name, value);
      }
      int GetEnvironmentString(const char  name, char  value) {
          return decoder_get_environment_string(info, name, value);
      }
      int UnsetEnvironment(const char  name) {
          return decoder_unset_environment(info, name);
      }
      int AddEnvironmentListener(const char  name, void  client,
                                 XA_EnvironmentCallback callback,
                                 void   handle) {
          return decoder_add_environment_listener(info, name, client,
                                                  callback, handle);
      }
      int RemoveEnvironmentListener(void  handle) {
          return decoder_remove_environment_listener(info, handle);
      }
      int Decoder(void  output_buffer) {
          return decoder_decode(info, output_buffer);
      }
      int Play() {
          return decoder_play(info);
      }
  };
  #endif
   }
{$endif}*)
  { __DECODER_H__  }


{** FILE_INPUT.H **}

 function file_input_module_register(module : PXA_InputModule):LongInt; cdecl;

{** AUDIO_OUTPUT.H **}

 function audio_output_module_register(module : PXA_OutputModule):LongInt; cdecl;


{** XAUDIO.H **}

function player_new(var Player: Pointer; var Args: HWND): Integer; cdecl;
function player_delete(Player: Pointer): Integer; cdecl;
function player_set_priority(Player: Pointer; Priority: Cardinal): Integer; cdecl;
function player_get_priority(Player: Pointer): Integer; cdecl;
function xaudio_error_string(Code: Integer): PChar; cdecl;
function xaudio_get_api_version(ApiID: Integer): Cardinal; cdecl;
function control_message_send_N(Player: Pointer; Code: Integer): Integer; cdecl;
function control_message_send_P(Player: Pointer; Code: Integer; Pointer1: Pointer): Integer; cdecl;
function control_message_send_S(Player: Pointer; Code: Integer; Str1: PChar): Integer; cdecl;
function control_message_send_SS(Player: Pointer; Code: Integer; Str1, Str2: PChar): Integer; cdecl;
function control_message_send_SI(Player: Pointer; Code: Integer; Str1: PChar; Int1: Integer): Integer; cdecl;
function control_message_send_IPI(Player: Pointer; Code: Integer; Int1: Integer; Ptr1: Pointer; Int2: Integer): Integer; cdecl;
function control_message_send_I(Player: Pointer; Code: Integer; Int1: Integer): Integer; cdecl;
function control_message_send_II(Player: Pointer; Code: Integer; Int1, Int2: Integer): Integer; cdecl;
function control_message_send_III(Player: Pointer; Code: Integer; Int1, Int2, Int3: Integer): Integer; cdecl;
function control_message_send_IIII(Player: Pointer; Code: Integer; Int1, Int2, Int3, Int4: Integer): Integer; cdecl;



  implementation (**********************************************************)

{$linklib c}
{$linklib m}
{$linklib xa}


  function decoder_version(major:ppchar; minor:ppchar; state:ppchar):pchar;cdecl;external;

  function decoder_new(decoder:ppXA_DecoderInfo):longint;cdecl;external;

  function decoder_delete(decoder:pXA_DecoderInfo):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_module_register(decoder:pXA_DecoderInfo; module:pXA_InputModule):longint;cdecl;external;

  function decoder_input_module_query(decoder:pXA_DecoderInfo; module:longint; query:pXA_InputModuleQuery; query_flags:cardinal):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_add_filter(decoder:pXA_DecoderInfo; filter:pXA_InputFilter; where:longint):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_remove_filter(decoder:pXA_DecoderInfo; name:pchar; id:longint):longint;cdecl;external;

  function decoder_input_filters_list(decoder:pXA_DecoderInfo; client:pointer; callback:difl_proc):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_new(decoder:pXA_DecoderInfo; name:pchar; module:longint):longint;cdecl;external;

  function decoder_input_delete(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_input_open(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_input_close(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_input_read(decoder:pXA_DecoderInfo; buffer:pointer; size:longint):longint;cdecl;external;

  function decoder_input_seek_to_offset(decoder:pXA_DecoderInfo; offset:cardinal):longint;cdecl;external;

  function decoder_input_seek_to_position(decoder:pXA_DecoderInfo; position:float):longint;cdecl;external;

  function decoder_input_seek_to_time(decoder:pXA_DecoderInfo; seconds:float):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_seek_to_timecode(decoder:pXA_DecoderInfo; timecode:pXA_TimeCode):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_input_send_message(decoder:pXA_DecoderInfo; type_:longint; data:pointer; size:cardinal):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_output_module_register(decoder:pXA_DecoderInfo; module:pXA_OutputModule):longint;cdecl;external;

  function decoder_output_module_query(decoder:pXA_DecoderInfo; module:longint; query:pXA_OutputModuleQuery; query_flags:cardinal):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_output_add_filter(decoder:pXA_DecoderInfo; filter:pXA_OutputFilter; where:longint):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_output_remove_filter(decoder:pXA_DecoderInfo; name:pchar; id:longint):longint;cdecl;external;

  function decoder_output_filters_list(decoder:pXA_DecoderInfo; client:pointer; callback:dofl_proc):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_output_new(decoder:pXA_DecoderInfo; name:pchar; module:longint):longint;cdecl;external;

  function decoder_output_delete(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_output_open(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_output_close(decoder:pXA_DecoderInfo):longint;cdecl;external;

  function decoder_output_write(decoder:pXA_DecoderInfo; buffer:pointer; size:cardinal; bytes_per_sample:longint; stereo:longint;
             sample_rate:longint):longint;cdecl;external;

  function decoder_output_set_control(decoder:pXA_DecoderInfo; control:pXA_OutputControl; control_flags:cardinal):longint;cdecl;external;

  function decoder_output_get_control(decoder:pXA_DecoderInfo; control:pXA_OutputControl; control_flags:cardinal):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_output_send_message(decoder:pXA_DecoderInfo; type_:longint; data:pointer; size:cardinal):longint;cdecl;external;

  function decoder_codec_set_equalizer(decoder:pXA_DecoderInfo; equalizer:pXA_EqualizerInfo):longint;cdecl;external;

  function decoder_codec_get_equalizer(decoder:pXA_DecoderInfo; equalizer:pXA_EqualizerInfo):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_set_environment_integer(decoder:pXA_DecoderInfo; name:pchar; value:longint):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_get_environment_integer(decoder:pXA_DecoderInfo; name:pchar; value:plongint):longint;cdecl;external;

(* Const before type ignored *)
(* Const before type ignored *)
  function decoder_set_environment_string(decoder:pXA_DecoderInfo; name:pchar; value:pchar):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_get_environment_string(decoder:pXA_DecoderInfo; name:pchar; value:pchar):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_unset_environment(decoder:pXA_DecoderInfo; name:pchar):longint;cdecl;external;

(* Const before type ignored *)
  function decoder_add_environment_listener(decoder:pXA_DecoderInfo; name:pchar; client:pointer; callback:XA_EnvironmentCallback; handle:ppointer):longint;cdecl;external;

  function decoder_remove_environment_listener(decoder:pXA_DecoderInfo; handle:pointer):longint;cdecl;external;

  function decoder_decode(decoder:pXA_DecoderInfo; output_buffer:pointer):longint;cdecl;external;

  function decoder_play(decoder:pXA_DecoderInfo):longint;cdecl;external;


{** FILE_INPUT.H **}

 function file_input_module_register(module : PXA_InputModule):LongInt; cdecl; external;

{** AUDIO_OUTPUT.H **}

 function audio_output_module_register(module : PXA_OutputModule):LongInt; cdecl; external;


{** XAUDIO.H **}

function player_new;                            cdecl; external;
function player_delete;                         cdecl; external;
function player_set_priority;                   cdecl; external;
function player_get_priority;                   cdecl; external;
function xaudio_error_string;                   cdecl; external;
function xaudio_get_api_version;                cdecl; external;
function control_message_send_N;                cdecl; external;
function control_message_send_P;                cdecl; external;
function control_message_send_S;                cdecl; external;
function control_message_send_SS;               cdecl; external;
function control_message_send_SI;               cdecl; external;
function control_message_send_IPI;              cdecl; external;
function control_message_send_I;                cdecl; external;
function control_message_send_II;               cdecl; external;
function control_message_send_III;              cdecl; external;
function control_message_send_IIII;             cdecl; external;



end.
